package org.appfuse.service;

import junit.framework.TestCase;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.appfuse.model.User;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class UserManagerTest extends TestCase {
    private static Log log = LogFactory.getLog(UserManagerTest.class);
    private ApplicationContext ctx;
    private User user = null;
    private UserManager mgr = null;

    protected void setUp() throws Exception {
        String[] paths = {"/WEB-INF/applicationContext*.xml"};
        ctx = new ClassPathXmlApplicationContext(paths);
        mgr = (UserManager) ctx.getBean("userManager");
    }
    
    public void testAddUser() throws Exception {
        user = new User();
        user.setFirstName("Easter");
        user.setLastName("Bunny");
        
        mgr.saveUser(user);
        
        assertTrue(user.getId() != null);
    }
}
