package org.appfuse.web;

import java.util.Map;

import org.apache.cactus.ServletTestCase;
import org.apache.cactus.WebRequest;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.appfuse.service.UserManager;
import org.springframework.context.ApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;
import org.springframework.web.servlet.ModelAndView;

public class UserCactusTest extends ServletTestCase {
    private static Log log = LogFactory.getLog(UserCactusTest.class);
    private UserController list = new UserController();
    private UserFormController form = new UserFormController();
    //private UserController list = null;
    //private UserFormController form = null;
    
    protected void setUp() throws Exception {
        super.setUp();
        ApplicationContext ctx = WebApplicationContextUtils
                .getRequiredWebApplicationContext(session.getServletContext());
        UserManager userManager = (UserManager) ctx.getBean("userManager");
        list.setUserManager(userManager);
        form.setUserManager(userManager);
        // needed to prevent NPE with getMessageSourceAccessor()
        form.setApplicationContext(ctx);
        /*
        list = (UserController) ctx.getBean("userController");
        form = (UserFormController) ctx.getBean("userFormController");
        */
    }
    
    public void beginAddUser(WebRequest wRequest) {
        wRequest.addParameter("firstName", "Dion", "post");
        wRequest.addParameter("lastName", "Almaer", "post");
    }
    
    public void testAddUser() throws Exception {
    	form.handleRequest(request, response);
        assertTrue(request.getSession().getAttribute("message") != null);
    }
    
    public void testUserList() throws Exception {
        ModelAndView mav = list.handleRequest(request, response);
        Map m = mav.getModel();
        assertNotNull(m.get("users"));
        assertEquals(mav.getViewName(), "userList");
        
    }
}