package org.appfuse.web;

import java.util.ArrayList;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import junit.framework.TestCase;

import org.appfuse.service.UserManager;
import org.easymock.MockControl;
import org.springframework.web.servlet.ModelAndView;


public class UserControllerEMTest extends TestCase {
    private MockControl control = null;
    private UserManager mockManager = null;
    private UserController c = new UserController();

    protected void setUp() throws Exception {
        control = MockControl.createControl(UserManager.class);
        mockManager = (UserManager) control.getMock();
        c.setUserManager(mockManager);
    }

    public void testGetUsers() throws Exception {
        // set expected behavior on manager
        mockManager.getUsers();
        control.setReturnValue(new ArrayList());
        
        // switch from record to playback
        control.replay();

        ModelAndView mav =
            c.handleRequest((HttpServletRequest) null,
                            (HttpServletResponse) null);
        Map m = mav.getModel();
        assertNotNull(m.get("users"));
        assertEquals(mav.getViewName(), "userList");
        
        // verify getUsers() was called on manager
        control.verify();
    }
}
